Bug 437132 - Firefox crashes in gtk dialog
Firefox crashes in gtk dialog
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gtk+ (Show other bugs)
i386 Linux
high Severity high
: rc
: ---
Assigned To: Matthias Clasen
Depends On: 433823
Blocks: 441780
  Show dependency treegraph
Reported: 2008-03-12 11:47 EDT by Martin Stransky
Modified: 2008-05-29 09:32 EDT (History)
12 users (show)

See Also:
Fixed In Version: RHEL-5.2
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-05-29 09:32:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
backtrace (61.35 KB, text/plain)
2008-03-12 11:49 EDT, Martin Stransky
no flags Details
bt2 (9.97 KB, text/plain)
2008-03-12 11:52 EDT, Martin Stransky
no flags Details
bt3 (7.40 KB, text/plain)
2008-03-12 11:52 EDT, Martin Stransky
no flags Details
possible patch for crash in comment 2 (734 bytes, patch)
2008-03-12 15:31 EDT, Jonathan Peatfield
no flags Details | Diff

  None (edit)
Description Martin Stransky 2008-03-12 11:47:24 EDT
Firefox crashes when it tries to open a new GTK dialog. The crash is inside GTK.
Comment 1 Martin Stransky 2008-03-12 11:49:17 EDT
Created attachment 297790 [details]
Comment 2 Martin Stransky 2008-03-12 11:52:02 EDT
Created attachment 297793 [details]
Comment 3 Martin Stransky 2008-03-12 11:52:34 EDT
Created attachment 297794 [details]
Comment 4 Jonathan Peatfield 2008-03-12 12:28:20 EDT
The crash in the bt for comment #2 seems likely to be the null callback_data in
a call to moz_container_forall() as mentioned in

That suggested patch just adds a trivial check on callback_data before
attempting to walk the moz_container->children calling their widget callbacks...

Comment 6 Jonathan Peatfield 2008-03-12 15:31:22 EDT
Created attachment 297832 [details]
possible patch for crash in comment 2

From the http://bugs.activestate.com/show_bug.cgi?id=64037 just so a copy is
here too.  Adding that to firefox- (and it applies to thunderbird
too!) certainly seems to help reduce a number of crashes here...

I've not yet tested it with the other patches added in firefox-

(personally I don't use firefox but many of our users here seem to...)
Comment 7 Jonathan Peatfield 2008-03-14 15:54:26 EDT
I'm currently rebuilding our test version of ffox to include the extra two
patches from your firefox- srpm as well as the gtk fix above.  If all
goes well I plan to push that out to about ~400 machines here in the next few
days.  I'll let you know how that goes.

The tests with just adding the gtk-fix seem to have reduced the number of
crashes quite a lot and the remaining ones *mostly* seem to be related to sites
using lots of annoying flash animations (like 6 adverts on one page all
competing for your attention...)

Long (long*) ago the flash plugin was so buggy that we didn't enable it by
default, and had to provide a wrapper which allowed people to turn it on for
sites which needed it.  I hope we don't need to go back to that... :-(

 -- Jon
Comment 8 Jonathan Peatfield 2008-03-31 21:52:13 EDT
Well as promised I'm including an update.

I'd like to confirm that the extra patch seems to help though we were still
getting a few crashes.  As of friday we are using a version based on the new
security update firefox- with this (and the empty-doc) patch with no
obvious ill effects.

Most of the remaining crashes *seem* to be inside the flash plugin, though
obviously we havn't been running the new version for long enough to be really sure.

 -- Jon
Comment 9 Christopher Aillon 2008-04-09 23:26:01 EDT
Though the fix isn't a good fix, as admitted in the activestate bug...

It defeats legitimate callbacks, so we need to find a better fix here.
Comment 10 Martin Stransky 2008-04-11 05:19:04 EDT
The bug is in GTK and a fix is available (see

So it should be fixed in GTK.
Comment 11 Jonathan Peatfield 2008-04-11 16:25:48 EDT
That is certainly *a* bug in GTK with a fix available - which should obviously
be fixed in GTK.

Since the discussion in there seems to be related to problems with re-parenting
an object when it is dragged in a notebook it isn't entirely obvious that this
is the bug which is causing ffox (and tbird etc) to crash - or at least not
obviously the *only* bug...
Comment 12 Matthias Clasen 2008-04-11 16:32:29 EDT
The cited GTK+ change can _not_ fix any firefox crash in RHEL5 - for the simple
reason that there is not notebook tab DND in the GTK+ thats shipped with RHEL5.
Comment 13 Martin Stransky 2008-05-29 09:32:55 EDT
Hopefully fixed by the RHEL-5.2 update. Please reopen if not.

Note You need to log in before you can comment on or make changes to this bug.